#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum MetadataSortField {
    #[serde(rename = "ALPHABETICAL")]
    Alphabetical,
    #[serde(rename = "USAGE_COUNT")]
    UsageCount,
    #[serde(rename = "PROPERTY_VALUE_COUNT")]
    PropertyValueCount,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl MetadataSortField {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            MetadataSortField::Alphabetical => "ALPHABETICAL",
            MetadataSortField::UsageCount => "USAGE_COUNT",
            MetadataSortField::PropertyValueCount => "PROPERTY_VALUE_COUNT",
            MetadataSortField::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for MetadataSortField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for MetadataSortField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for MetadataSortField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<MetadataSortField, conjure_object::plain::ParseEnumError> {
        match v {
            "ALPHABETICAL" => Ok(MetadataSortField::Alphabetical),
            "USAGE_COUNT" => Ok(MetadataSortField::UsageCount),
            "PROPERTY_VALUE_COUNT" => Ok(MetadataSortField::PropertyValueCount),
            v => v.parse().map(|v| MetadataSortField::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for MetadataSortField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<MetadataSortField, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the MetadataSortField enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
